; bitflip_delay_inline.a51		bitflip program, with delay for full-speed operation
; rev path 3/16
	$NOSYMBOLS													; keeps listing short
	$INCLUDE (C:\SiLabs\MCU\INC\c8051f410.inc) 

	ORG 0					; tells assembler the address at which to place this code
	
            ; Disable the WDT.
          ANL PCA0MD, #NOT(040h)   ; Clear Watchdog Enable bit; Enable the Port I/O Crossbar
          MOV   XBR1, #40h           ; Enable Crossbar
	        ; ...and this time we'll let the processor run full-speed (we omit the usual divide-by-eight line)	
          MOV OSCICN, #87h

          MOV A,#0			; maximize two delay values (0 is max because dec before test)
          MOV B,#0			; ...and second loop delay value

          SETB P0.0			;  start with LED OFF (it's active low)
          
DELAY:      MOV R4, #60h        ; 1 second delay: this multiplies the 64K other loops
INNERLOOP:	DJNZ B, INNERLOOP		; count down innermost loop, till inner hits zero
           DJNZ ACC,INNERLOOP	; ...then dec second loop, and start inner again.
           DJNZ R4, INNERLOOP	; now, with second at zero, decrement the outermost loop 
			
          CPL P0.0             ; toggle LED
          SJMP DELAY

END 
